import unittest
from hcache import Cached, cached

class A(Cached):
    @cached
    def foo(self, n):
        return [n]

    @property
    @cached
    def bar(self):
        return [11]

class TestCache(unittest.TestCase):
    def test_cache(self):
        a = A()
        r1 = a.foo(5)
        r2 = a.foo(5)
        a.foo(6)
        r3 = a.foo(5)

        self.assertTrue(r1 is r2)
        self.assertTrue(r1 is not r3)

    def test_cache_property(self):
        a = A()
        r1 = a.bar
        r2 = a.bar
        self.assertTrue(r1 is r2)

if __name__ == '__main__':
    unittest.main()
